## ros-melodic-nanomsg 0.4.1

=== CMakeLists.txt ===
##############################################################################
# Cmake
##############################################################################

cmake_minimum_required(VERSION 2.8.3)
include(CheckSymbolExists)
project(nanomsg)

##############################################################################
# Find Packages
##############################################################################

find_package(catkin REQUIRED)

##############################################################################
# Catkin
##############################################################################

catkin_package(
  INCLUDE_DIRS .
  LIBRARIES ${PROJECT_NAME}
  # DEPENDS # should somehow get -pthreads and -lanl in here
)

##############################################################################
# Project Configuration
##############################################################################

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu99")

list(APPEND CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(accept4 sys/socket.h HAVE_ACCEPT4)
list(REMOVE_ITEM CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)

if(HAVE_ACCEPT4)
  add_definitions(
    -DHAVE_ACCEPT4
    -DNN_HAVE_ACCEPT4
  )
endif()

# Currently no easy way of detecting if __sync_fetch_and_add_4
# is supported, so define this from outside if you get the following error:
#
#    libnanomsg.so: undefined reference to `__sync_fetch_and_add_4'
#
# We found it wasn't supported on our arm1176jzf-s/2.6.32 platform.
if(NOT DEFINED NN_DISABLE_ATOMIC_GCC_BUILTINS)
  add_definitions(-DNN_HAVE_GCC_ATOMIC_BUILTINS)
endif()

# Warning: the remaining have been blindly grabbed from a ./configure on
# ubuntu amd64 trusty
add_definitions(
    -DHAVE_PTHREAD_PRIO_INHERIT
    -DSTDC_HEADERS
    -DHAVE_SYS_TYPES_H
    -DHAVE_SYS_STAT_H
    -DHAVE_STDLIB_H
    -DHAVE_STRING_H
    -DHAVE_MEMORY_H
    -DHAVE_STRINGS_H
    -DHAVE_INTTYPES_H
    -DHAVE_STDINT_H
    -DHAVE_UNISTD_H
    -DHAVE_NETINET_IN_H
    -DHAVE_NETDB_H
    -DHAVE_ARPA_INET_H
    -DHAVE_UNISTD_H
    -DHAVE_SYS_SOCKET_H
    -DHAVE_SYS_IOCTL_H
    -DNN_HAVE_STDINT
    -DHAVE_EVENTFD
    -DNN_HAVE_EVENTFD
    -DHAVE_PIPE
    -DNN_HAVE_PIPE
    -DHAVE_PIPE2
    -DNN_HAVE_PIPE2
    -DHAVE_CLOCK_GETTIME
    -DHAVE_POLL
    -DNN_HAVE_POLL
    -DHAVE_EPOLL_CREATE
    -DNN_USE_EPOLL
    -DHAVE_GETIFADDRS
    -DNN_USE_IFADDRS
    -DNN_HAVE_GETADDRINFO_A
    -DNN_HAVE_SOCKETPAIR
    -DNN_HAVE_SEMAPHORE
    -DNN_USE_EVENTFD
    -DHAVE_DLFCN_H
    -D_GNU_SOURCE -D_GNU_SOURCE -D_GNU_SOURCE
)

##############################################################################
# Sources
##############################################################################

add_subdirectory(nanomsg)

=== nanomsg/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg)

###############################################################################
# Libraries
###############################################################################

set (NN_SOURCES
    core/ep.c
    core/epbase.c
    core/global.c
    core/pipe.c
    core/poll.c
    core/sock.c
    core/sockbase.c
    core/device.c
    core/symbol.c

    aio/ctx.c
    aio/fsm.c
    aio/poller.c
    aio/poller_epoll.inc
    aio/poller_kqueue.inc
    aio/poller_poll.inc
    aio/pool.c
    aio/timer.c
    aio/timerset.c
    aio/usock.c
    aio/usock_posix.inc
    aio/usock_win.inc
    aio/worker.c
    aio/worker_posix.inc
    aio/worker_win.inc

    utils/alloc.c
    utils/atomic.c
    utils/chunk.c
    utils/chunkref.c
    utils/clock.c
    utils/closefd.c
    utils/efd.c
    utils/efd_eventfd.inc
    utils/efd_pipe.inc
    utils/efd_socketpair.inc
    utils/efd_win.inc
    utils/err.c
    utils/glock.c
    utils/hash.c
    utils/list.c
    utils/msg.c
    utils/mutex.c
    utils/queue.c
    utils/random.c
    utils/sem.c
    utils/sleep.c
    utils/thread.c
    utils/thread_posix.inc
    utils/thread_win.inc
    utils/wire.c

    protocols/utils/dist.c
    protocols/utils/excl.c
    protocols/utils/fq.c
    protocols/utils/lb.c
    protocols/utils/priolist.c

    protocols/bus/bus.c
    protocols/bus/xbus.c

    protocols/pipeline/push.c
    protocols/pipeline/pull.c
    protocols/pipeline/xpull.c
    protocols/pipeline/xpush.c

    protocols/pair/pair.c
    protocols/pair/xpair.c

    protocols/pubsub/pub.c
    protocols/pubsub/sub.c
    protocols/pubsub/trie.c
    protocols/pubsub/xpub.c
    protocols/pubsub/xsub.c

    protocols/reqrep/req.c
    protocols/reqrep/rep.c
    protocols/reqrep/xrep.c
    protocols/reqrep/xreq.c

    protocols/survey/respondent.c
    protocols/survey/surveyor.c
    protocols/survey/xrespondent.c
    protocols/survey/xsurveyor.c

    transports/utils/backoff.c
    transports/utils/dns.c
    transports/utils/dns_getaddrinfo.inc
    transports/utils/dns_getaddrinfo_a.inc
    transports/utils/iface.c
    transports/utils/literal.c
    transports/utils/port.c
    transports/utils/streamhdr.c

    transports/inproc/binproc.c
    transports/inproc/cinproc.c
    transports/inproc/inproc.c
    transports/inproc/ins.c
    transports/inproc/msgqueue.c
    transports/inproc/sinproc.c

    transports/ipc/aipc.c
    transports/ipc/bipc.c
    transports/ipc/cipc.c
    transports/ipc/ipc.c
    transports/ipc/sipc.c

    transports/tcp/atcp.c
    transports/tcp/btcp.c
    transports/tcp/ctcp.c
    transports/tcp/stcp.c
    transports/tcp/tcp.c
)

add_library (nanomsg ${NN_SOURCES})

target_link_libraries(nanomsg anl ${CMAKE_THREAD_LIBS_INIT})

###############################################################################
# Install
###############################################################################

install(TARGETS nanomsg
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin)

###############################################################################
# Directories
###############################################################################

add_subdirectory(aio)
add_subdirectory(core)
add_subdirectory(protocols)
add_subdirectory(transports)
add_subdirectory(utils)

=== nanomsg/aio/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/aio)

=== nanomsg/core/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/core)

=== nanomsg/protocols/CMakeLists.txt ===
###############################################################################
# Directories
###############################################################################

add_subdirectory(bus)
add_subdirectory(pair)
add_subdirectory(pipeline)
add_subdirectory(pubsub)
add_subdirectory(reqrep)
add_subdirectory(survey)
add_subdirectory(utils)

=== nanomsg/transports/CMakeLists.txt ===
###############################################################################
# Directories
###############################################################################

add_subdirectory(inproc)
add_subdirectory(ipc)
add_subdirectory(tcp)
add_subdirectory(utils)

=== nanomsg/utils/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/utils)

=== nanomsg/protocols/bus/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/protocols/bus)

=== nanomsg/protocols/pair/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/protocols/pair)

=== nanomsg/protocols/pipeline/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/protocols/pipeline)

=== nanomsg/protocols/pubsub/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/protocols/pubsub)

=== nanomsg/protocols/reqrep/CMakeLists.txt ===
###############################################################################
# Headers
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.h)

install(FILES ${HEADERS} DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/nanomsg/protocols/reqrep)

=== debian/changelog ===
ros-melodic-nanomsg (0.4.1-0bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Daniel Stonier <d.stonier@gmail.com>  Mon, 08 Oct 2018 11:24:10 -0000

=== debian/control ===
Source: ros-melodic-nanomsg
Section: misc
Priority: extra
Maintainer: Daniel Stonier <d.stonier@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-melodic-catkin
Homepage: 
Standards-Version: 3.9.2

Package: ros-melodic-nanomsg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, 
Description: The nanomsg package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/melodic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/melodic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/melodic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-melodic-nanomsg//opt/ros/melodic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/melodic/setup.sh" ]; then . "/opt/ros/melodic/setup.sh"; fi && \
	dh_auto_install
